<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="fr" xml:lang="fr"><head>
<meta content="text/html; charset=ISO-8859-1" http-equiv="Content-Type" />
<!--
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
              This file is generated from xml source: DO NOT EDIT
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
      -->
<title>Limites des descripteurs de fichiers - Serveur Apache HTTP Version 2.4</title>
<link href="../style/css/manual.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-loose-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" /><link rel="stylesheet" type="text/css" href="../style/css/prettify.css" />
<script src="../style/scripts/prettify.min.js" type="text/javascript">
</script>

<link href="../images/favicon.ico" rel="shortcut icon" /></head>
<body id="manual-page" class="no-sidebar"><div id="page-header">
<p class="menu"><a href="../mod/">Modules</a> | <a href="../mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="../glossary.html">Glossaire</a> | <a href="../sitemap.html">Plan du site</a></p>
<p class="apache">Serveur Apache HTTP Version 2.4</p>
<img alt="" src="../images/feather.png" /></div>
<div class="up"><a href="./"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path">
<a href="http://www.apache.org/">Apache</a> &gt; <a href="http://httpd.apache.org/">Serveur HTTP</a> &gt; <a href="http://httpd.apache.org/docs/">Documentation</a> &gt; <a href="../">Version 2.4</a> &gt; <a href="./">Serveurs Virtuels</a></div><div id="page-content"><div id="preamble"><h1>Limites des descripteurs de fichiers</h1>
<div class="toplang">
<p><span>Langues Disponibles: </span><a href="../en/vhosts/fd-limits.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="../fr/vhosts/fd-limits.html" title="Franais">&nbsp;fr&nbsp;</a> |
<a href="../ja/vhosts/fd-limits.html" hreflang="ja" rel="alternate" title="Japanese">&nbsp;ja&nbsp;</a> |
<a href="../ko/vhosts/fd-limits.html" hreflang="ko" rel="alternate" title="Korean">&nbsp;ko&nbsp;</a> |
<a href="../tr/vhosts/fd-limits.html" hreflang="tr" rel="alternate" title="Trke">&nbsp;tr&nbsp;</a></p>
</div>


    <p>Quand de nombreux serveurs virtuels sont crs, Apache peut
    dpasser les limites en descripteurs de fichiers ('file descriptors',
    galement appels <cite>gestionnaires de fichiers</cite>) si chacun
    des serveurs virtuels utilise ses propres fichiers journaux. Le
    nombre total de descripteurs de fichiers utiliss par Apache est
    d'un par fichier journal, un pour chacune des autres directives
    de fichiers journaux, plus un nombre constant compris entre 10 et 20
    pour son fonctionnement interne. Les systmes d'exploitation Unix
    limitent le nombre de descripteurs de fichiers utilisables par
    processus&nbsp;; une valeur courante pour cette limite est de 64, et
    cette valeur peut le plus souvent tre augmente.</p>

    <p>Apache tente d'accrotre cette valeur limite si ncessaire, mais
    sans y parvenir dans les cas suivants&nbsp;:</p>

    <ol>
      <li>Le systme d'exploitation ne permet pas l'utilisation d'appels
      systmes <code>setrlimit()</code>.</li>

      <li>L'appel <code>setrlimit(RLIMIT_NOFILE)</code> ne fonctionne pas
      sur votre systme d'exploitation (c'est le cas sous Solaris 2.3).</li>

      <li>Le nombre de descripteurs de fichiers ncessaires  Apache
      dpasse la limite physique du matriel.</li>

      <li>Le systme impose d'autres limites sur l'utilisation des
      descripteurs de fichiers, comme par exemple une limite sur les
      flux stdio, utilisables uniquement sur les descripteurs de
      fichiers infrieurs  256. (sous Solaris 2).</li>
    </ol>

    <p>En cas de problme, Vous pouvez&nbsp;:</p>

    <ul>
      <li>Rduire le nombre de fichiers journaux, en ne spcifiant
      aucun fichier journal dans les sections
      <code class="directive"><a href="../mod/core.html#virtualhost">&lt;VirtualHost&gt;</a></code>,
      en donc en envoyant les informations aux fichiers journaux du
      serveur principal (Voir <a href="#splitlogs">clatement des
      fichiers journaux</a> ci-dessous pour plus d'informations sur
      cette possibilit).</li>

      <li>
        Dans les cas 1 ou 2 (voqus ci-dessus), augmentez la limite sur
        les descripteurs de fichiers avant le dmarrage d'Apache, au
        moyen d'un script comme

        <div class="example"><p><code>
          <code>#!/bin/sh<br />
           ulimit -S -n 100<br />
           exec httpd</code>
        </code></p></div>
      </li>
    </ul>



</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="splitlogs" id="splitlogs">clatement des fichiers journaux</a></h2>

<p>Lorsque vous choisissez d'enregistrer les informations manant de
plusieurs serveurs virtuels dans un mme fichier journal, vous voudrez
ensuite pouvoir scinder ces informations  des fins de statistiques, par
exemple, sur les diffrents serveurs virtuels. Il est possible de procder
de la manire suivante&nbsp;:</p>

<p>Tout d'abord, vous devez ajouter le nom du serveur virtuel  chaque
entre du journal. Ceci se paramtre au moyen de la directive
<code class="directive"><a href="../mod/mod_log_config.html#logformat"> LogFormat</a></code> et de la
variable <code>%v</code>. Ajoutez cette variable au dbut de la chane
de dfinition du format de journalisations&nbsp;:</p>

<pre class="prettyprint lang-config">LogFormat "%v %h %l %u %t \"%r\" %&gt;s %b" vhost
CustomLog logs/multiple_vhost_log vhost</pre>


<p>Cette configuration va provoquer la cration d'un fichier de
journalisation au format standard (CLF&nbsp;: 'Common Log Format'), mais dont
chaque ligne dbutera par le nom canonique du serveur virtuel (spcifi
par la directive <code class="directive"><a href="../mod/core.html#servername">ServerName</a></code>).
(Voir <code class="module"><a href="../mod/mod_log_config.html">mod_log_config</a></code> pour d'autres informations sur la
personnalisation des fichiers journaux.)</p>

<p>Au moment de sparer les informations du fichier journal en un fichier
par serveur virtuel, le programme <code>
<a href="../programs/other.html">split-logfile</a></code> peut tre
utilis. Ce programme peut tre trouv dans le rpertoire
<code>support</code> de la distribution d'Apache.</p>

<p>Excutez ce programme au moyen de la commande&nbsp;:</p>

<div class="example"><p><code>
split-logfile &lt; /logs/multiple_vhost_log
</code></p></div>

<p>Une fois excut avec le nom du fichier contenant tous les journaux,
ce programme va gnrer un fichier pour chacun des serveurs virtuels
qui apparat dans le fichier d'entre. Chaque fichier en sortie est
nomm <code>nomduserveur.log</code>.</p>

</div></div>
<div class="bottomlang">
<p><span>Langues Disponibles: </span><a href="../en/vhosts/fd-limits.html" hreflang="en" rel="alternate" title="English">&nbsp;en&nbsp;</a> |
<a href="../fr/vhosts/fd-limits.html" title="Franais">&nbsp;fr&nbsp;</a> |
<a href="../ja/vhosts/fd-limits.html" hreflang="ja" rel="alternate" title="Japanese">&nbsp;ja&nbsp;</a> |
<a href="../ko/vhosts/fd-limits.html" hreflang="ko" rel="alternate" title="Korean">&nbsp;ko&nbsp;</a> |
<a href="../tr/vhosts/fd-limits.html" hreflang="tr" rel="alternate" title="Trke">&nbsp;tr&nbsp;</a></p>
</div><div class="top"><a href="#page-header"><img src="../images/up.gif" alt="top" /></a></div><div class="section"><h2><a id="comments_section" name="comments_section">Commentaires</a></h2><div class="warning"><strong>Notice:</strong><br />This is not a Q&amp;A section. Comments placed here should be pointed towards suggestions on improving the documentation or server, and may be removed again by our moderators if they are either implemented or considered invalid/off-topic. Questions on how to manage the Apache HTTP Server should be directed at either our IRC channel, #httpd, on Freenode, or sent to our <a href="http://httpd.apache.org/lists.html">mailing lists</a>.</div>
<script type="text/javascript"><!--//--><![CDATA[//><!--
var comments_shortname = 'httpd';
var comments_identifier = 'http://httpd.apache.org/docs/2.4/vhosts/fd-limits.html';
(function(w, d) {
    if (w.location.hostname.toLowerCase() == "httpd.apache.org") {
        d.write('<div id="comments_thread"><\/div>');
        var s = d.createElement('script');
        s.type = 'text/javascript';
        s.async = true;
        s.src = 'https://comments.apache.org/show_comments.lua?site=' + comments_shortname + '&page=' + comments_identifier;
        (d.getElementsByTagName('head')[0] || d.getElementsByTagName('body')[0]).appendChild(s);
    }
    else { 
        d.write('<div id="comments_thread">Comments are disabled for this page at the moment.<\/div>');
    }
})(window, document);
//--><!]]></script></div><div id="footer">
<p class="apache">Copyright 2017 The Apache Software Foundation.<br />Autoris sous <a href="http://www.apache.org/licenses/LICENSE-2.0">Apache License, Version 2.0</a>.</p>
<p class="menu"><a href="../mod/">Modules</a> | <a href="../mod/directives.html">Directives</a> | <a href="http://wiki.apache.org/httpd/FAQ">FAQ</a> | <a href="../glossary.html">Glossaire</a> | <a href="../sitemap.html">Plan du site</a></p></div><script type="text/javascript"><!--//--><![CDATA[//><!--
if (typeof(prettyPrint) !== 'undefined') {
    prettyPrint();
}
//--><!]]></script>
</body></html>